diff --git a/src/backend/commands/proclang.c b/src/backend/commands/proclang.c
index d4c6a16cd01..2486eb7df83 100644
--- a/src/backend/commands/proclang.c
+++ b/src/backend/commands/proclang.c
@@ -46,9 +46,9 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 	Oid			funcargtypes[1];
 	Relation	rel;
 	TupleDesc	tupDesc;
-	Datum		values[Natts_pg_language];
-	bool		nulls[Natts_pg_language];
-	bool		replaces[Natts_pg_language];
+	Datum		values[Natts_pg_language] = {0};
+	bool		nulls[Natts_pg_language] = {false};
+	Bitmapset  *updated = NULL;
 	NameData	langname;
 	HeapTuple	oldtup;
 	HeapTuple	tup;
@@ -104,19 +104,15 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 	tupDesc = RelationGetDescr(rel);
 
 	/* Prepare data to be inserted */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, true, sizeof(replaces));
-
 	namestrcpy(&langname, languageName);
-	values[Anum_pg_language_lanname - 1] = NameGetDatum(&langname);
-	values[Anum_pg_language_lanowner - 1] = ObjectIdGetDatum(languageOwner);
-	values[Anum_pg_language_lanispl - 1] = BoolGetDatum(true);
-	values[Anum_pg_language_lanpltrusted - 1] = BoolGetDatum(stmt->pltrusted);
-	values[Anum_pg_language_lanplcallfoid - 1] = ObjectIdGetDatum(handlerOid);
-	values[Anum_pg_language_laninline - 1] = ObjectIdGetDatum(inlineOid);
-	values[Anum_pg_language_lanvalidator - 1] = ObjectIdGetDatum(valOid);
-	nulls[Anum_pg_language_lanacl - 1] = true;
+	HeapTupleUpdateValue(pg_language, lanname, NameGetDatum(&langname), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, lanowner, ObjectIdGetDatum(languageOwner), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, lanispl, BoolGetDatum(true), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, lanpltrusted, BoolGetDatum(stmt->pltrusted), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, lanplcallfoid, ObjectIdGetDatum(handlerOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, laninline, ObjectIdGetDatum(inlineOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_language, lanvalidator, ObjectIdGetDatum(valOid), values, nulls, updated);
+	HeapTupleUpdateValueNull(pg_language, lanacl, values, nulls, updated);
 
 	/* Check for pre-existing definition */
 	oldtup = SearchSysCache1(LANGNAME, PointerGetDatum(languageName));
@@ -142,13 +138,13 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 		 * Do not change existing oid, ownership or permissions.  Note
 		 * dependency-update code below has to agree with this decision.
 		 */
-		replaces[Anum_pg_language_oid - 1] = false;
-		replaces[Anum_pg_language_lanowner - 1] = false;
-		replaces[Anum_pg_language_lanacl - 1] = false;
+		HeapTupleSetColumnNotUpdated(pg_language, oid, updated);
+		HeapTupleSetColumnNotUpdated(pg_language, lanowner, updated);
+		HeapTupleSetColumnNotUpdated(pg_language, lanacl, updated);
 
 		/* Okay, do it... */
-		tup = heap_modify_tuple(oldtup, tupDesc, values, nulls, replaces);
-		CatalogTupleUpdate(rel, &tup->t_self, tup);
+		tup = heap_update_tuple(oldtup, tupDesc, values, nulls, updated);
+		CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 		langoid = oldform->oid;
 		ReleaseSysCache(oldtup);
@@ -157,11 +153,10 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 	else
 	{
 		/* Creating a new language */
-		langoid = GetNewOidWithIndex(rel, LanguageOidIndexId,
-									 Anum_pg_language_oid);
-		values[Anum_pg_language_oid - 1] = ObjectIdGetDatum(langoid);
+		langoid = GetNewOidWithIndex(rel, LanguageOidIndexId, Anum_pg_language_oid);
+		HeapTupleUpdateValue(pg_language, oid, ObjectIdGetDatum(langoid), values, nulls, updated);
 		tup = heap_form_tuple(tupDesc, values, nulls);
-		CatalogTupleInsert(rel, tup);
+		CatalogTupleInsert(rel, tup, NULL);
 		is_update = false;
 	}
 
@@ -213,6 +208,7 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 	InvokeObjectPostCreateHook(LanguageRelationId, myself.objectId, 0);
 
 	table_close(rel, RowExclusiveLock);
+	bms_free(updated);
 
 	return myself;
 }
diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index fc3a4c19e65..59a7e6bed1f 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -833,8 +833,8 @@ CreatePublication(ParseState *pstate, CreatePublicationStmt *stmt)
 	Relation	rel;
 	ObjectAddress myself;
 	Oid			puboid;
-	bool		nulls[Natts_pg_publication];
-	Datum		values[Natts_pg_publication];
+	Datum		values[Natts_pg_publication] = {0};
+	bool		nulls[Natts_pg_publication] = {false};
 	HeapTuple	tup;
 	bool		publish_given;
 	PublicationActions pubactions;
@@ -876,9 +876,8 @@ CreatePublication(ParseState *pstate, CreatePublicationStmt *stmt)
 	memset(values, 0, sizeof(values));
 	memset(nulls, false, sizeof(nulls));
 
-	values[Anum_pg_publication_pubname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(stmt->pubname));
-	values[Anum_pg_publication_pubowner - 1] = ObjectIdGetDatum(GetUserId());
+	HeapTupleSetValue(pg_publication, pubname, DirectFunctionCall1(namein, CStringGetDatum(stmt->pubname)), values);
+	HeapTupleSetValue(pg_publication, pubowner, ObjectIdGetDatum(GetUserId()), values);
 
 	parse_publication_options(pstate,
 							  stmt->options,
@@ -897,28 +896,20 @@ CreatePublication(ParseState *pstate, CreatePublicationStmt *stmt)
 
 	puboid = GetNewOidWithIndex(rel, PublicationObjectIndexId,
 								Anum_pg_publication_oid);
-	values[Anum_pg_publication_oid - 1] = ObjectIdGetDatum(puboid);
-	values[Anum_pg_publication_puballtables - 1] =
-		BoolGetDatum(stmt->for_all_tables);
-	values[Anum_pg_publication_puballsequences - 1] =
-		BoolGetDatum(stmt->for_all_sequences);
-	values[Anum_pg_publication_pubinsert - 1] =
-		BoolGetDatum(pubactions.pubinsert);
-	values[Anum_pg_publication_pubupdate - 1] =
-		BoolGetDatum(pubactions.pubupdate);
-	values[Anum_pg_publication_pubdelete - 1] =
-		BoolGetDatum(pubactions.pubdelete);
-	values[Anum_pg_publication_pubtruncate - 1] =
-		BoolGetDatum(pubactions.pubtruncate);
-	values[Anum_pg_publication_pubviaroot - 1] =
-		BoolGetDatum(publish_via_partition_root);
-	values[Anum_pg_publication_pubgencols - 1] =
-		CharGetDatum(publish_generated_columns);
+	HeapTupleSetValue(pg_publication, oid, ObjectIdGetDatum(puboid), values);
+	HeapTupleSetValue(pg_publication, puballtables, BoolGetDatum(stmt->for_all_tables), values);
+	HeapTupleSetValue(pg_publication, puballsequences, BoolGetDatum(stmt->for_all_sequences), values);
+	HeapTupleSetValue(pg_publication, pubinsert, BoolGetDatum(pubactions.pubinsert), values);
+	HeapTupleSetValue(pg_publication, pubupdate, BoolGetDatum(pubactions.pubupdate), values);
+	HeapTupleSetValue(pg_publication, pubdelete, BoolGetDatum(pubactions.pubdelete), values);
+	HeapTupleSetValue(pg_publication, pubtruncate, BoolGetDatum(pubactions.pubtruncate), values);
+	HeapTupleSetValue(pg_publication, pubviaroot, BoolGetDatum(publish_via_partition_root), values);
+	HeapTupleSetValue(pg_publication, pubgencols, CharGetDatum(publish_generated_columns), values);
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
 	/* Insert tuple into catalog. */
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 	heap_freetuple(tup);
 
 	recordDependencyOnOwner(PublicationRelationId, puboid, GetUserId());
@@ -1001,9 +992,9 @@ static void
 AlterPublicationOptions(ParseState *pstate, AlterPublicationStmt *stmt,
 						Relation rel, HeapTuple tup)
 {
-	bool		nulls[Natts_pg_publication];
-	bool		replaces[Natts_pg_publication];
-	Datum		values[Natts_pg_publication];
+	Datum		values[Natts_pg_publication] = {0};
+	bool		nulls[Natts_pg_publication] = {false};
+	Bitmapset  *updated = NULL;
 	bool		publish_given;
 	PublicationActions pubactions;
 	bool		publish_via_partition_root_given;
@@ -1113,42 +1104,25 @@ AlterPublicationOptions(ParseState *pstate, AlterPublicationStmt *stmt,
 	}
 
 	/* Everything ok, form a new tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-
 	if (publish_given)
 	{
-		values[Anum_pg_publication_pubinsert - 1] = BoolGetDatum(pubactions.pubinsert);
-		replaces[Anum_pg_publication_pubinsert - 1] = true;
-
-		values[Anum_pg_publication_pubupdate - 1] = BoolGetDatum(pubactions.pubupdate);
-		replaces[Anum_pg_publication_pubupdate - 1] = true;
-
-		values[Anum_pg_publication_pubdelete - 1] = BoolGetDatum(pubactions.pubdelete);
-		replaces[Anum_pg_publication_pubdelete - 1] = true;
-
-		values[Anum_pg_publication_pubtruncate - 1] = BoolGetDatum(pubactions.pubtruncate);
-		replaces[Anum_pg_publication_pubtruncate - 1] = true;
+		HeapTupleUpdateValue(pg_publication, pubinsert, BoolGetDatum(pubactions.pubinsert), values, nulls, updated);
+		HeapTupleUpdateValue(pg_publication, pubupdate, BoolGetDatum(pubactions.pubupdate), values, nulls, updated);
+		HeapTupleUpdateValue(pg_publication, pubdelete, BoolGetDatum(pubactions.pubdelete), values, nulls, updated);
+		HeapTupleUpdateValue(pg_publication, pubtruncate, BoolGetDatum(pubactions.pubtruncate), values, nulls, updated);
 	}
 
 	if (publish_via_partition_root_given)
-	{
-		values[Anum_pg_publication_pubviaroot - 1] = BoolGetDatum(publish_via_partition_root);
-		replaces[Anum_pg_publication_pubviaroot - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_publication, pubviaroot, BoolGetDatum(publish_via_partition_root), values, nulls, updated);
 
 	if (publish_generated_columns_given)
-	{
-		values[Anum_pg_publication_pubgencols - 1] = CharGetDatum(publish_generated_columns);
-		replaces[Anum_pg_publication_pubgencols - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_publication, pubgencols, CharGetDatum(publish_generated_columns), values, nulls, updated);
 
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel), values, nulls,
-							replaces);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 
 	/* Update the catalog. */
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+	bms_free(updated);
 
 	CommandCounterIncrement();
 
@@ -2053,6 +2027,7 @@ static void
 AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_publication form;
+	Bitmapset  *updated = NULL;
 
 	form = (Form_pg_publication) GETSTRUCT(tup);
 
@@ -2089,8 +2064,10 @@ AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 		}
 	}
 
-	form->pubowner = newOwnerId;
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	HeapTupleUpdateField(pg_publication, pubowner, newOwnerId, form, updated);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+
+	bms_free(updated);
 
 	/* Update owner dependency reference */
 	changeDependencyOnOwner(PublicationRelationId,
diff --git a/src/backend/commands/schemacmds.c b/src/backend/commands/schemacmds.c
index 4c51e920626..d3a6dc4da36 100644
--- a/src/backend/commands/schemacmds.c
+++ b/src/backend/commands/schemacmds.c
@@ -255,6 +255,7 @@ RenameSchema(const char *oldname, const char *newname)
 	AclResult	aclresult;
 	ObjectAddress address;
 	Form_pg_namespace nspform;
+	Bitmapset  *updated = NULL;
 
 	rel = table_open(NamespaceRelationId, RowExclusiveLock);
 
@@ -292,7 +293,8 @@ RenameSchema(const char *oldname, const char *newname)
 
 	/* rename */
 	namestrcpy(&nspform->nspname, newname);
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	HeapTupleMarkColumnUpdated(pg_namespace, nspname, updated);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 	InvokeObjectPostAlterHook(NamespaceRelationId, nspOid, 0);
 
@@ -300,6 +302,7 @@ RenameSchema(const char *oldname, const char *newname)
 
 	table_close(rel, NoLock);
 	heap_freetuple(tup);
+	bms_free(updated);
 
 	return address;
 }
@@ -374,14 +377,14 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 	 */
 	if (nspForm->nspowner != newOwnerId)
 	{
-		Datum		repl_val[Natts_pg_namespace];
-		bool		repl_null[Natts_pg_namespace];
-		bool		repl_repl[Natts_pg_namespace];
+		Datum		values[Natts_pg_namespace] = {0};
+		bool		nulls[Natts_pg_namespace] = {false};
 		Acl		   *newAcl;
 		Datum		aclDatum;
 		bool		isNull;
 		HeapTuple	newtuple;
 		AclResult	aclresult;
+		Bitmapset  *updated = NULL;
 
 		/* Otherwise, must be owner of the existing object */
 		if (!object_ownercheck(NamespaceRelationId, nspForm->oid, GetUserId()))
@@ -406,11 +409,7 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 			aclcheck_error(aclresult, OBJECT_DATABASE,
 						   get_database_name(MyDatabaseId));
 
-		memset(repl_null, false, sizeof(repl_null));
-		memset(repl_repl, false, sizeof(repl_repl));
-
-		repl_repl[Anum_pg_namespace_nspowner - 1] = true;
-		repl_val[Anum_pg_namespace_nspowner - 1] = ObjectIdGetDatum(newOwnerId);
+		HeapTupleUpdateValue(pg_namespace, nspowner, ObjectIdGetDatum(newOwnerId), values, nulls, updated);
 
 		/*
 		 * Determine the modified ACL for the new owner.  This is only
@@ -423,19 +422,19 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 		{
 			newAcl = aclnewowner(DatumGetAclP(aclDatum),
 								 nspForm->nspowner, newOwnerId);
-			repl_repl[Anum_pg_namespace_nspacl - 1] = true;
-			repl_val[Anum_pg_namespace_nspacl - 1] = PointerGetDatum(newAcl);
+			HeapTupleUpdateValue(pg_namespace, nspacl, PointerGetDatum(newAcl), values, nulls, updated);
 		}
 
-		newtuple = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val, repl_null, repl_repl);
+		newtuple = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 
-		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
 
 		heap_freetuple(newtuple);
 
 		/* Update owner dependency reference */
 		changeDependencyOnOwner(NamespaceRelationId, nspForm->oid,
 								newOwnerId);
+		bms_free(updated);
 	}
 
 	InvokeObjectPostAlterHook(NamespaceRelationId,
diff --git a/src/backend/commands/seclabel.c b/src/backend/commands/seclabel.c
index 4160f5b6855..e4a56f4d569 100644
--- a/src/backend/commands/seclabel.c
+++ b/src/backend/commands/seclabel.c
@@ -334,18 +334,16 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 	SysScanDesc scan;
 	HeapTuple	oldtup;
 	HeapTuple	newtup = NULL;
-	Datum		values[Natts_pg_shseclabel];
-	bool		nulls[Natts_pg_shseclabel];
-	bool		replaces[Natts_pg_shseclabel];
+	Datum		values[Natts_pg_shseclabel] = {0};
+	bool		nulls[Natts_pg_shseclabel] = {false};
+	Bitmapset  *updated = NULL;
 
 	/* Prepare to form or update a tuple, if necessary. */
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-	values[Anum_pg_shseclabel_objoid - 1] = ObjectIdGetDatum(object->objectId);
-	values[Anum_pg_shseclabel_classoid - 1] = ObjectIdGetDatum(object->classId);
-	values[Anum_pg_shseclabel_provider - 1] = CStringGetTextDatum(provider);
+	HeapTupleUpdateValue(pg_shseclabel, objoid, ObjectIdGetDatum(object->objectId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_shseclabel, classoid, ObjectIdGetDatum(object->classId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_shseclabel, provider, CStringGetTextDatum(provider), values, nulls, updated);
 	if (label != NULL)
-		values[Anum_pg_shseclabel_label - 1] = CStringGetTextDatum(label);
+		HeapTupleUpdateValue(pg_shseclabel, label, CStringGetTextDatum(label), values, nulls, updated);
 
 	/* Use the index to search for a matching old tuple */
 	ScanKeyInit(&keys[0],
@@ -373,10 +371,9 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 			CatalogTupleDelete(pg_shseclabel, &oldtup->t_self);
 		else
 		{
-			replaces[Anum_pg_shseclabel_label - 1] = true;
-			newtup = heap_modify_tuple(oldtup, RelationGetDescr(pg_shseclabel),
-									   values, nulls, replaces);
-			CatalogTupleUpdate(pg_shseclabel, &oldtup->t_self, newtup);
+			HeapTupleUpdateValue(pg_shseclabel, label, CStringGetTextDatum(label), values, nulls, updated);
+			newtup = heap_update_tuple(oldtup, RelationGetDescr(pg_shseclabel), values, nulls, updated);
+			CatalogTupleUpdate(pg_shseclabel, &oldtup->t_self, newtup, updated, NULL);
 		}
 	}
 	systable_endscan(scan);
@@ -386,13 +383,14 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 	{
 		newtup = heap_form_tuple(RelationGetDescr(pg_shseclabel),
 								 values, nulls);
-		CatalogTupleInsert(pg_shseclabel, newtup);
+		CatalogTupleInsert(pg_shseclabel, newtup, NULL);
 	}
 
 	if (newtup != NULL)
 		heap_freetuple(newtup);
 
 	table_close(pg_shseclabel, RowExclusiveLock);
+	bms_free(updated);
 }
 
 /*
@@ -409,9 +407,9 @@ SetSecurityLabel(const ObjectAddress *object,
 	SysScanDesc scan;
 	HeapTuple	oldtup;
 	HeapTuple	newtup = NULL;
-	Datum		values[Natts_pg_seclabel];
-	bool		nulls[Natts_pg_seclabel];
-	bool		replaces[Natts_pg_seclabel];
+	Datum		values[Natts_pg_seclabel] = {0};
+	bool		nulls[Natts_pg_seclabel] = {false};
+	Bitmapset  *updated = NULL;
 
 	/* Shared objects have their own security label catalog. */
 	if (IsSharedRelation(object->classId))
@@ -421,14 +419,12 @@ SetSecurityLabel(const ObjectAddress *object,
 	}
 
 	/* Prepare to form or update a tuple, if necessary. */
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-	values[Anum_pg_seclabel_objoid - 1] = ObjectIdGetDatum(object->objectId);
-	values[Anum_pg_seclabel_classoid - 1] = ObjectIdGetDatum(object->classId);
-	values[Anum_pg_seclabel_objsubid - 1] = Int32GetDatum(object->objectSubId);
-	values[Anum_pg_seclabel_provider - 1] = CStringGetTextDatum(provider);
+	HeapTupleUpdateValue(pg_seclabel, objoid, ObjectIdGetDatum(object->objectId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_seclabel, classoid, ObjectIdGetDatum(object->classId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_seclabel, objsubid, Int32GetDatum(object->objectSubId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_seclabel, provider, CStringGetTextDatum(provider), values, nulls, updated);
 	if (label != NULL)
-		values[Anum_pg_seclabel_label - 1] = CStringGetTextDatum(label);
+		HeapTupleUpdateValue(pg_seclabel, label, CStringGetTextDatum(label), values, nulls, updated);
 
 	/* Use the index to search for a matching old tuple */
 	ScanKeyInit(&keys[0],
@@ -460,10 +456,9 @@ SetSecurityLabel(const ObjectAddress *object,
 			CatalogTupleDelete(pg_seclabel, &oldtup->t_self);
 		else
 		{
-			replaces[Anum_pg_seclabel_label - 1] = true;
-			newtup = heap_modify_tuple(oldtup, RelationGetDescr(pg_seclabel),
-									   values, nulls, replaces);
-			CatalogTupleUpdate(pg_seclabel, &oldtup->t_self, newtup);
+			HeapTupleUpdateValue(pg_seclabel, label, CStringGetTextDatum(label), values, nulls, updated);
+			newtup = heap_update_tuple(oldtup, RelationGetDescr(pg_seclabel), values, nulls, updated);
+			CatalogTupleUpdate(pg_seclabel, &oldtup->t_self, newtup, updated, NULL);
 		}
 	}
 	systable_endscan(scan);
@@ -471,9 +466,8 @@ SetSecurityLabel(const ObjectAddress *object,
 	/* If we didn't find an old tuple, insert a new one */
 	if (newtup == NULL && label != NULL)
 	{
-		newtup = heap_form_tuple(RelationGetDescr(pg_seclabel),
-								 values, nulls);
-		CatalogTupleInsert(pg_seclabel, newtup);
+		newtup = heap_form_tuple(RelationGetDescr(pg_seclabel), values, nulls);
+		CatalogTupleInsert(pg_seclabel, newtup, NULL);
 	}
 
 	/* Update indexes, if necessary */
@@ -481,6 +475,7 @@ SetSecurityLabel(const ObjectAddress *object,
 		heap_freetuple(newtup);
 
 	table_close(pg_seclabel, RowExclusiveLock);
+	bms_free(updated);
 }
 
 /*
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index e1b808bbb60..a060211d6a4 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -125,8 +125,8 @@ DefineSequence(ParseState *pstate, CreateSeqStmt *seq)
 	TupleDesc	tupDesc;
 	Datum		value[SEQ_COL_LASTCOL];
 	bool		null[SEQ_COL_LASTCOL];
-	Datum		pgs_values[Natts_pg_sequence];
-	bool		pgs_nulls[Natts_pg_sequence];
+	Datum		pgs_values[Natts_pg_sequence] = {0};
+	bool		pgs_nulls[Natts_pg_sequence] = {false};
 	int			i;
 
 	/*
@@ -221,17 +221,17 @@ DefineSequence(ParseState *pstate, CreateSeqStmt *seq)
 
 	memset(pgs_nulls, 0, sizeof(pgs_nulls));
 
-	pgs_values[Anum_pg_sequence_seqrelid - 1] = ObjectIdGetDatum(seqoid);
-	pgs_values[Anum_pg_sequence_seqtypid - 1] = ObjectIdGetDatum(seqform.seqtypid);
-	pgs_values[Anum_pg_sequence_seqstart - 1] = Int64GetDatumFast(seqform.seqstart);
-	pgs_values[Anum_pg_sequence_seqincrement - 1] = Int64GetDatumFast(seqform.seqincrement);
-	pgs_values[Anum_pg_sequence_seqmax - 1] = Int64GetDatumFast(seqform.seqmax);
-	pgs_values[Anum_pg_sequence_seqmin - 1] = Int64GetDatumFast(seqform.seqmin);
-	pgs_values[Anum_pg_sequence_seqcache - 1] = Int64GetDatumFast(seqform.seqcache);
-	pgs_values[Anum_pg_sequence_seqcycle - 1] = BoolGetDatum(seqform.seqcycle);
+	HeapTupleSetValue(pg_sequence, seqrelid, ObjectIdGetDatum(seqoid), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqtypid, ObjectIdGetDatum(seqform.seqtypid), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqstart, Int64GetDatumFast(seqform.seqstart), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqincrement, Int64GetDatumFast(seqform.seqincrement), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqmax, Int64GetDatumFast(seqform.seqmax), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqmin, Int64GetDatumFast(seqform.seqmin), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqcache, Int64GetDatumFast(seqform.seqcache), pgs_values);
+	HeapTupleSetValue(pg_sequence, seqcycle, BoolGetDatum(seqform.seqcycle), pgs_values);
 
 	tuple = heap_form_tuple(tupDesc, pgs_values, pgs_nulls);
-	CatalogTupleInsert(rel, tuple);
+	CatalogTupleInsert(rel, tuple, NULL);
 
 	heap_freetuple(tuple);
 	table_close(rel, RowExclusiveLock);
@@ -444,6 +444,7 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 	bool		is_called;
 	int64		last_value;
 	HeapTuple	newdatatuple;
+	Bitmapset  *updated = NULL;
 
 	/* Open and lock sequence, and check for ownership along the way. */
 	relid = RangeVarGetRelidExtended(stmt->sequence,
@@ -525,8 +526,15 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 	if (owned_by)
 		process_owned_by(seqrel, owned_by, stmt->for_identity);
 
+	/*
+	 * Mark all sequence columns as potentially updated since init_params can
+	 * modify any field
+	 */
+	HeapTupleUpdateSetAllColumnsUpdated(pg_sequence, updated);
+
 	/* update the pg_sequence tuple (we could skip this in some cases...) */
-	CatalogTupleUpdate(rel, &seqtuple->t_self, seqtuple);
+	CatalogTupleUpdate(rel, &seqtuple->t_self, seqtuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RelationRelationId, relid, 0);
 
diff --git a/src/backend/commands/statscmds.c b/src/backend/commands/statscmds.c
index c1da79f36ba..9d9e2261c3f 100644
--- a/src/backend/commands/statscmds.c
+++ b/src/backend/commands/statscmds.c
@@ -71,8 +71,8 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 	Oid			namespaceId;
 	Oid			stxowner = GetUserId();
 	HeapTuple	htup;
-	Datum		values[Natts_pg_statistic_ext];
-	bool		nulls[Natts_pg_statistic_ext];
+	Datum		values[Natts_pg_statistic_ext] = {0};
+	bool		nulls[Natts_pg_statistic_ext] = {false};
 	int2vector *stxkeys;
 	List	   *stxexprs = NIL;
 	Datum		exprsDatum;
@@ -531,22 +531,22 @@ CreateStatistics(CreateStatsStmt *stmt, bool check_rights)
 
 	statoid = GetNewOidWithIndex(statrel, StatisticExtOidIndexId,
 								 Anum_pg_statistic_ext_oid);
-	values[Anum_pg_statistic_ext_oid - 1] = ObjectIdGetDatum(statoid);
-	values[Anum_pg_statistic_ext_stxrelid - 1] = ObjectIdGetDatum(relid);
-	values[Anum_pg_statistic_ext_stxname - 1] = NameGetDatum(&stxname);
-	values[Anum_pg_statistic_ext_stxnamespace - 1] = ObjectIdGetDatum(namespaceId);
-	values[Anum_pg_statistic_ext_stxowner - 1] = ObjectIdGetDatum(stxowner);
-	values[Anum_pg_statistic_ext_stxkeys - 1] = PointerGetDatum(stxkeys);
-	nulls[Anum_pg_statistic_ext_stxstattarget - 1] = true;
-	values[Anum_pg_statistic_ext_stxkind - 1] = PointerGetDatum(stxkind);
-
-	values[Anum_pg_statistic_ext_stxexprs - 1] = exprsDatum;
+	HeapTupleSetValue(pg_statistic_ext, oid, ObjectIdGetDatum(statoid), values);
+	HeapTupleSetValue(pg_statistic_ext, stxrelid, ObjectIdGetDatum(relid), values);
+	HeapTupleSetValue(pg_statistic_ext, stxname, NameGetDatum(&stxname), values);
+	HeapTupleSetValue(pg_statistic_ext, stxnamespace, ObjectIdGetDatum(namespaceId), values);
+	HeapTupleSetValue(pg_statistic_ext, stxowner, ObjectIdGetDatum(stxowner), values);
+	HeapTupleSetValue(pg_statistic_ext, stxkeys, PointerGetDatum(stxkeys), values);
+	HeapTupleSetValueNull(pg_statistic_ext, stxstattarget, values, nulls);
+	HeapTupleSetValue(pg_statistic_ext, stxkind, PointerGetDatum(stxkind), values);
+
+	HeapTupleSetValue(pg_statistic_ext, stxexprs, exprsDatum, values);
 	if (exprsDatum == (Datum) 0)
-		nulls[Anum_pg_statistic_ext_stxexprs - 1] = true;
+		HeapTupleSetValueNull(pg_statistic_ext, stxexprs, values, nulls);
 
 	/* insert it into pg_statistic_ext */
 	htup = heap_form_tuple(statrel->rd_att, values, nulls);
-	CatalogTupleInsert(statrel, htup);
+	CatalogTupleInsert(statrel, htup, NULL);
 	heap_freetuple(htup);
 
 	relation_close(statrel, RowExclusiveLock);
@@ -642,9 +642,9 @@ AlterStatistics(AlterStatsStmt *stmt)
 	Oid			stxoid;
 	HeapTuple	oldtup;
 	HeapTuple	newtup;
-	Datum		repl_val[Natts_pg_statistic_ext];
-	bool		repl_null[Natts_pg_statistic_ext];
-	bool		repl_repl[Natts_pg_statistic_ext];
+	Datum		values[Natts_pg_statistic_ext] = {0};
+	bool		nulls[Natts_pg_statistic_ext] = {false};
+	Bitmapset  *updated = NULL;
 	ObjectAddress address;
 	int			newtarget = 0;
 	bool		newtarget_default;
@@ -719,23 +719,16 @@ AlterStatistics(AlterStatsStmt *stmt)
 		aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_STATISTIC_EXT,
 					   NameListToString(stmt->defnames));
 
-	/* Build new tuple. */
-	memset(repl_val, 0, sizeof(repl_val));
-	memset(repl_null, false, sizeof(repl_null));
-	memset(repl_repl, false, sizeof(repl_repl));
-
 	/* replace the stxstattarget column */
-	repl_repl[Anum_pg_statistic_ext_stxstattarget - 1] = true;
 	if (!newtarget_default)
-		repl_val[Anum_pg_statistic_ext_stxstattarget - 1] = Int16GetDatum(newtarget);
+		HeapTupleUpdateValue(pg_statistic_ext, stxstattarget, Int16GetDatum(newtarget), values, nulls, updated);
 	else
-		repl_null[Anum_pg_statistic_ext_stxstattarget - 1] = true;
+		HeapTupleUpdateValueNull(pg_statistic_ext, stxstattarget, values, nulls, updated);
 
-	newtup = heap_modify_tuple(oldtup, RelationGetDescr(rel),
-							   repl_val, repl_null, repl_repl);
+	newtup = heap_update_tuple(oldtup, RelationGetDescr(rel), values, nulls, updated);
 
 	/* Update system catalog. */
-	CatalogTupleUpdate(rel, &newtup->t_self, newtup);
+	CatalogTupleUpdate(rel, &newtup->t_self, newtup, updated, NULL);
 
 	InvokeObjectPostAlterHook(StatisticExtRelationId, stxoid, 0);
 
@@ -746,6 +739,7 @@ AlterStatistics(AlterStatsStmt *stmt)
 	 * other fields, there is no need to update dependencies.
 	 */
 
+	bms_free(updated);
 	heap_freetuple(newtup);
 	ReleaseSysCache(oldtup);
 
